package com.example.mmad.testapp.command;

import com.example.mmad.testapp.entity.UserEntity;
import com.example.mmad.testapp.event.UserCreatedEvent;
import com.example.mmad.testapp.repository.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.stereotype.Service;

@Service
public class UserCommandHandler {
    @Autowired
    private ApplicationEventPublisher applicationEventPublisher;
    private final UserRepository userRepository;

    public UserCommandHandler(UserRepository userRepository) {
        this.userRepository = userRepository;
    }

    public void createUser(CreateUserCommand createUserCommand) {
        UserEntity userEntity = new UserEntity();
        userEntity.setId(createUserCommand.getUserId());
        userEntity.setUserName(createUserCommand.getUserName());
        userEntity.setEmail(createUserCommand.getEmail());
//        userRepository.save(userEntity);
        UserCreatedEvent event = new UserCreatedEvent(
                userEntity.getId(),
                userEntity.getUserName(),
                userEntity.getEmail()
        );
        applicationEventPublisher.publishEvent(event);
    }
}
