package com.example.mmad.testapp.repository;

import com.example.mmad.testapp.entity.PersonEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

@Repository
public interface PersonRepository extends JpaRepository<PersonEntity, Long> {

    @Query(value = "select id,first_name,last_name from mmaddb.testapp.person  where id =:id", nativeQuery = true)
    PersonEntity gerPersonById(Long id);

    @Modifying
    @Query(value = "delete from mmaddb.testapp.person where id=:id", nativeQuery = true)
    void deleteById(Long id);

    @Modifying
    @Query(value = "update mmaddb.testapp.person set first_name=:firstName, last_name=:lastName where id = :id",nativeQuery = true)
    void updatePersonById(String firstName,String lastName,Long id);
}
